%define wayland_ver 1.24
%global apiver   14
%global libname  %mklibname weston  %{libapiver}
%global libdevel %mklibname weston -d

%bcond_without freerdp

# "fix" underlinking:
%define _disable_ld_no_undefined 1

%global meson_prob 0

Summary:	The Weston Wayland Compositor
Name:		weston
Version:	%{apiver}.0.1
Release:	%mkrel 2
License:	MIT
Group:		Graphics/Utilities
Url:		https://wayland.freedesktop.org/
Source0:        https://gitlab.freedesktop.org/wayland/%{name}/-/archive/%{version}/%{name}-%{version}.tar.gz
# Backport from upstream
## Allow neatvnc 0.9.0 as a build dependency
Patch0:         https://gitlab.freedesktop.org/wayland/weston/-/merge_requests/1649.patch
BuildRequires:	meson
BuildRequires:	pkgconfig(cairo) >= 1.10.0
BuildRequires:	pkgconfig(cairo-xcb)
BuildRequires:	pkgconfig(colord) >= 0.1.27
BuildRequires:	pkgconfig(dbus-1) >= 1.6
BuildRequires:	pkgconfig(egl)
%if %{with freerdp}
BuildRequires:	pkgconfig(freerdp2)
%endif
BuildRequires:	pkgconfig(gbm) >= 10.2
BuildRequires:	pkgconfig(glesv2)
BuildRequires:	pkgconfig(glu)
BuildRequires:	pkgconfig(gstreamer-1.0)
BuildRequires:	pkgconfig(gstreamer-allocators-1.0)
BuildRequires:	pkgconfig(lcms2)
BuildRequires:	pkgconfig(libdisplay-info)
BuildRequires:	pkgconfig(libdrm) >= 2.4.30
BuildRequires:	pkgconfig(libevdev)
BuildRequires:	pkgconfig(libinput) >= 0.8.0
BuildRequires:	pkgconfig(libpng)
BuildRequires:	pkgconfig(libsystemd)  >= 209
BuildRequires:	pkgconfig(libudev) >= 136
BuildRequires:	pkgconfig(libunwind)
BuildRequires:	pkgconfig(libva) >= 0.34.0
BuildRequires:	pkgconfig(libva-drm) >= 0.34.0
BuildRequires:	pkgconfig(libwebp)
BuildRequires:	pkgconfig(libxml-2.0) >= 2.6
BuildRequires:	pkgconfig(mtdev) >= 1.1.0
BuildRequires:	pkgconfig(neatvnc)
BuildRequires:	pkgconfig(pangocairo)
BuildRequires:	pkgconfig(pixman-1) >= 0.25.2
BuildRequires:	pkgconfig(libseat)
BuildRequires:	pkgconfig(poppler-glib)
BuildRequires:	pkgconfig(wayland-client) >= 1.12.0
BuildRequires:	pkgconfig(wayland-cursor)
BuildRequires:	pkgconfig(wayland-egl)
BuildRequires:	pkgconfig(wayland-protocols) >= 1.18
BuildRequires:	pkgconfig(wayland-scanner)
BuildRequires:	pkgconfig(wayland-server)
BuildRequires:	pkgconfig(x11)
BuildRequires:	pkgconfig(x11-xcb)
BuildRequires:	pkgconfig(xcb)
BuildRequires:	pkgconfig(xcb-composite)
BuildRequires:	pkgconfig(xcb-cursor)
BuildRequires:	pkgconfig(xcb-shm)
BuildRequires:	pkgconfig(xcb-xfixes)
BuildRequires:	pkgconfig(xcb-xkb)
BuildRequires:	pkgconfig(xcursor)
BuildRequires:	pkgconfig(xkbcommon)
BuildRequires:	pkgconfig(xwayland)
BuildRequires:	pkgconfig(libpipewire-0.3)
BuildRequires:	pam-devel
BuildRequires:	pkgconfig(libjpeg)
Requires:	x11-data-xkbdata

%description
Weston is the reference implementation of a Wayland compositor, and a
useful compositor in its own right. Weston has various backends that
lets it run on Linux kernel modesetting and evdev input as well as
under X11.
There is also a quite capable terminal emulator (weston-terminal) and
an toy/example desktop shell. Finally, Weston also provides
integration with the Xorg server and can pull X clients into the
Wayland desktop and act as a X window manager.

%package        libs
Summary:        Weston compositor libraries
Group:          System/Libraries

%description    libs
This package contains Weston compositor libraries.

%package -n %libdevel
Summary:        Common headers for weston
Group:          Development/C
License:        MIT

%description -n %libdevel
Common headers for weston.

%prep
%autosetup -p1

%build
%if %{meson_prob}
%meson -Dpipewire=false
%else
%meson \
%if %{without freerdp}
	-Dbackend-rdp=false \
%endif
%endif
%meson_build

%install
%meson_install

for d in $(find clients/ -type f -not -name Makefile -and -not -name '*.*' -and -not -name '%{name}-*'); do
    install -m755 $d %{buildroot}%{_bindir}/%{name}-$(basename $d)
done

%files
%config %{_sysconfdir}/pam.d/weston-remote-access
%{_bindir}/%{name}
%{_bindir}/weston-[^l]*
%{_bindir}/wcap-decode
%{_libexecdir}/%{name}-*
%dir %{_libdir}/%{name}*/
%{_libdir}/%{name}/*.so
%{_libdir}/%{name}/*.so.*
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/*.png
%{_datadir}/%{name}/*.svg
%{_mandir}/man*/*
%{_datadir}/wayland-sessions/weston.desktop

%files libs
%license COPYING
%dir %{_libdir}/libweston-%{apiver}
%{_libdir}/libweston-%{apiver}/color-lcms.so
%{_libdir}/libweston-%{apiver}/drm-backend.so
%{_libdir}/libweston-%{apiver}/gl-renderer.so
%{_libdir}/libweston-%{apiver}/headless-backend.so
%{_libdir}/libweston-%{apiver}/pipewire-backend.so
%if !%{meson_prob}
%{_libdir}/libweston-%{apiver}/pipewire-plugin.so
%endif
%{_libdir}/libweston-%{apiver}/remoting-plugin.so
%if %{with freerdp}
%{_libdir}/libweston-%{apiver}/rdp-backend.so
%endif
%{_libdir}/libweston-%{apiver}/vnc-backend.so
%{_libdir}/libweston-%{apiver}/remoting-plugin.so
%{_libdir}/libweston-%{apiver}/wayland-backend.so
%{_libdir}/libweston-%{apiver}/x11-backend.so
%{_libdir}/libweston-%{apiver}/xwayland.so
%{_libdir}/libweston-%{apiver}.so.0*

%files -n %libdevel
%{_includedir}/libweston-%{apiver}/
%{_includedir}/weston/
%{_libdir}/pkgconfig/*.pc
%{_libdir}/libweston-%{apiver}.so
%{_datadir}/pkgconfig/libweston-%{apiver}-protocols.pc
%{_datadir}/libweston-%{apiver}/protocols/


%changelog
* Wed Dec 25 2024 daviddavid <daviddavid> 14.0.1-2.mga10
+ Revision: 2129970
- backport patch to allow neatvnc 0.9.0 as a dependency

* Wed Oct 23 2024 daviddavid <daviddavid> 14.0.1-1.mga10
+ Revision: 2110481
- new version: 14.0.1

* Fri Sep 27 2024 daviddavid <daviddavid> 14.0.0-1.mga10
+ Revision: 2101488
- new version: 14.0.0

* Fri Jul 05 2024 daviddavid <daviddavid> 13.0.3-2.mga10
+ Revision: 2079811
- rebuild for new libdisplay-info 0.2.0

* Thu Jun 27 2024 daviddavid <daviddavid> 13.0.3-1.mga10
+ Revision: 2077374
- new version: 13.0.3

* Fri Apr 26 2024 daviddavid <daviddavid> 13.0.1-1.mga10
+ Revision: 2061206
- new version: 13.0.1

* Thu Apr 25 2024 daviddavid <daviddavid> 13.0.0-2.mga10
+ Revision: 2060964
- enable libdisplay-info and xwayland support

* Thu Apr 25 2024 daviddavid <daviddavid> 13.0.0-1.mga10
+ Revision: 2060962
- new version: 13.0.0
+ tv <tv>
- Update to 12.0.2

* Wed Jan 04 2023 tv <tv> 11.0.1-1.mga9
+ Revision: 1929939
- Update to 11.0.1

* Sat Nov 05 2022 tv <tv> 11.0.0-1.mga9
+ Revision: 1903811
- Update to 11.0.0

* Thu Aug 11 2022 tmb <tmb> 10.0.2-1.mga9
+ Revision: 1877092
- update to 10.0.2

* Fri Apr 15 2022 tv <tv> 10.0.0-1.mga9
+ Revision: 1850254
- Update to 10.0.0

* Sun Apr 03 2022 umeabot <umeabot> 9.0.0-2.mga9
+ Revision: 1841630
- Mageia 9 Mass Rebuild

* Fri Sep 04 2020 tv <tv> 9.0.0-1.mga8
+ Revision: 1621908
- 9.0

* Fri Mar 13 2020 tv <tv> 8.0.0-4.mga8
+ Revision: 1556060
- disable pipewire support for now as the new version isn't supported

* Thu Feb 20 2020 umeabot <umeabot> 8.0.0-3.mga8
+ Revision: 1545625
- Mageia 8 Mass Rebuild

* Wed Jan 29 2020 tv <tv> 8.0.0-2.mga8
+ Revision: 1485027
- new release

* Tue Oct 22 2019 daviddavid <daviddavid> 7.0.0-2.mga8
+ Revision: 1455095
- enable freerdp support

* Tue Oct 22 2019 tv <tv> 7.0.0-1.mga8
+ Revision: 1455090
- BR pipewire
- BR pkgconfig(gstreamer-1.0)
- honor disabling freerdp
- switch to meson
- "fix" underlinking
- adjust filelist
- new release

* Sun Mar 31 2019 tv <tv> 6.0.0-1.mga7
+ Revision: 1383531
- fix underlinking
- new release
- new release
- 6.0 RC

* Sat Aug 25 2018 tv <tv> 5.0.0-1.mga7
+ Revision: 1253890
- new release

* Sun Aug 19 2018 tv <tv> 4.0.94-1.mga7
+ Revision: 1252781
- 5.0 RC2

* Tue Jun 12 2018 tv <tv> 4.0.0-3.mga7
+ Revision: 1236642
- disable freerdp support (failed to build with 2.0.0 RC2)
+ blino <blino>
- require x11-data-xkbdata for /usr/share/X11/xkb

* Tue Apr 10 2018 tv <tv> 4.0.0-1.mga7
+ Revision: 1216901
- new release

* Thu Apr 05 2018 tv <tv> 3.0.93-1.mga7
+ Revision: 1215350
- new release

* Fri Aug 11 2017 tv <tv> 3.0.0-1.mga7
+ Revision: 1139613
- new release

* Wed Aug 02 2017 tv <tv> 2.99.92-1.mga7
+ Revision: 1133931
- new release
- libify (there's libs now)
- enable rdp
- kill empty demos pkg
- use std macros

* Tue Jun 07 2016 tv <tv> 1.11.0-2.mga6
+ Revision: 1020636
- adjust BRs for latest systemd

* Wed Jun 01 2016 tv <tv> 1.11.0-1.mga6
+ Revision: 1019669
- 1.11.0

* Wed May 25 2016 tv <tv> 1.10.93-1.mga6
+ Revision: 1018248
- 1.11 RC1

* Wed May 18 2016 tv <tv> 1.10.91-1.mga6
+ Revision: 1016711
- new release

* Wed May 18 2016 tv <tv> 1.10.0-1.mga6
+ Revision: 1016702
- new release

* Wed Mar 16 2016 tv <tv> 1.9.92-1.mga6
+ Revision: 992172
- drop merged patches
- new release

* Wed Jan 20 2016 ovitters <ovitters> 1.9.91-1.mga6
+ Revision: 926155
- new version 1.9.91

* Sat Jan 02 2016 luigiwalser <luigiwalser> 1.9.0-2.mga6
+ Revision: 918207
- rebuild for libwebp

* Thu Sep 24 2015 tv <tv> 1.9.0-1.mga6
+ Revision: 883293
- new release

* Thu Jun 25 2015 tv <tv> 1.8.0-2.mga6
+ Revision: 843533
- adjust file list
- rebuild for new libinput
+ ovitters <ovitters>
- new version 1.8.0

* Wed Oct 15 2014 umeabot <umeabot> 1.6.0-2.mga5
+ Revision: 741368
- Second Mageia 5 Mass Rebuild

* Fri Sep 19 2014 tv <tv> 1.6.0-1.mga5
+ Revision: 697373
- new release
+ umeabot <umeabot>
- Mageia 5 Mass Rebuild

* Fri Sep 12 2014 tv <tv> 1.5.93-1.mga5
+ Revision: 674833
- 1.6 RC2

* Sat Sep 06 2014 tv <tv> 1.5.92-1.mga5
+ Revision: 672560
- 1.6 RC1

* Tue Sep 02 2014 ovitters <ovitters> 1.5.91-1.mga5
+ Revision: 670895
- new version 1.5.91

* Fri Jun 06 2014 tv <tv> 1.5.0-1.mga5
+ Revision: 633893
- new release

* Sat Feb 15 2014 luigiwalser <luigiwalser> 1.4.0-2.mga5
+ Revision: 592112
- rebuild for libwebp
+ neoclust <neoclust>
- New version 1.4.0

* Fri Nov 15 2013 tv <tv> 1.3.1-1.mga5
+ Revision: 551447
- new release

* Mon Oct 21 2013 umeabot <umeabot> 1.3.0-2.mga4
+ Revision: 541069
- Mageia 4 Mass Rebuild

* Fri Oct 11 2013 tv <tv> 1.3.0-1.mga4
+ Revision: 495049
- adjust file list

* Sat Sep 14 2013 wally <wally> 1.2.2-2.mga4
+ Revision: 478957
- rebuild for new colord

* Fri Aug 30 2013 tv <tv> 1.2.2-1.mga4
+ Revision: 473437
- adjust file list
- new release

* Sat Aug 17 2013 fwang <fwang> 1.2.0-2.mga4
+ Revision: 467155
- update file list
- xcb-xkb does not exist now
- cleanup br

* Sat Aug 17 2013 fwang <fwang> 1.2.0-1.mga4
+ Revision: 467145
- update file list
+ tv <tv>
- new release

* Mon Jun 10 2013 tv <tv> 1.1.1-1.mga4
+ Revision: 441777
- adjust file list
- adjust file list
- BR latest libunwind-devel
- new release

* Tue Jun 04 2013 fwang <fwang> 1.0.3-4.mga4
+ Revision: 436933
- rebuild for new libpng

* Mon Jan 14 2013 umeabot <umeabot> 1.0.3-3.mga3
+ Revision: 385683
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild
+ boklm <boklm>
- Update group: Graphics/Other -> Graphics/Utilities

* Wed Jan 02 2013 pterjan <pterjan> 1.0.3-2.mga3
+ Revision: 337495
- Fix for _libdir != _libexecdir

* Thu Dec 20 2012 kamil <kamil> 1.0.3-1.mga3
+ Revision: 333261
- update %%files
- new version 1.0.3, update Source0

* Tue Oct 23 2012 blino <blino> 1.0.0-1.mga3
+ Revision: 309359
- 1.0.0

* Wed Oct 17 2012 fwang <fwang> 0.99.0-1.mga3
+ Revision: 307714
- update file list
+ blino <blino>
- use Graphics/Other group
- 0.99.0

* Tue Aug 07 2012 blino <blino> 0.95.0-3.mga3
+ Revision: 279829
- fix package group

* Wed Jul 25 2012 blino <blino> 0.95.0-2.mga3
+ Revision: 274379
- update descriptions
- package demo clients in weston-demos

* Tue Jul 24 2012 blino <blino> 0.95.0-1.mga3
+ Revision: 274124
- buildrequire xcursor devel
- do not package wcap-snapshot (dropped upstream)
- 0.95.0

* Tue Jul 24 2012 blino <blino> 0.94.90-2.mga3
+ Revision: 273981
- weston-launch should be setuid root instead of weston
- buildrequire poppler-glib-devel instead
- buildrequire poppler-devel

* Tue Jul 24 2012 blino <blino> 0.94.90-1.mga3
+ Revision: 273906
- buildrequire libvpx-devel
- buildrequire systemd-devel
- buildrequire pam-devel
- package new files (wcap-*, weston-launch, screensaver, screenshoter)
- buildrequire mtdev devel
- require newer xkbcommon
- 0.94.90
- drop xkbcommon include patch cherry-pick

* Sun Jul 01 2012 colin <colin> 0.85.0-2.mga3
+ Revision: 265943
- Add missing BuildRequire on mesaglu-devel
- Rebuild for new libudev major

* Mon Mar 05 2012 blino <blino> 0.85.0-1.mga2
+ Revision: 218311
- buildrequire jpeg-devel
- buildrequire cairo devel
- buildrequire pixman and png devel packages
- initial release
- Created package structure for weston.

